View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20  package org.apache.mina.codec;
    21
    22  import java.nio.ByteBuffer;
    23
    24  /**
    25   * Decodes binary or protocol-specific data into higher-level message objects.
    26   *
    27   * Must be immutable, a CONTEXT will be provided per session.
    28   *
    29   * @param <INPUT> the incoming message to decode (the low level message, usually a {@link ByteBuffer})
    30   * @param <OUTPUT> the decoded message (your high level protocol Pojo/DTO)
    31   * @param <DECODING_STATE> the context where to save the current decoding state (e.g. accumulated bytes, encoding
    32   *        context switching..)
    33   *
    34   * @author <a href="http://mina.apache.org">Apache MINA Project</a>
    35   *
    36   */
    37  public interface ProtocolDecoder<INPUT, OUTPUT, DECODING_STATE> {
    38
    39      /**
    40       * Create a new session context for this decoder
    41       *
    42       * @return the newly created context
    43       */
    44      DECODING_STATE createDecoderState();
    45
    46      /**
    47       * Decode binary or protocol-specific content of type <code>INPUT</code> into higher-level protocol message objects,
    48       * of type OUTPUT
    49       *
    50       * @param input the received message to decode
    51       * @param context the decoding context (will be stored in the session for the next decode call)
    52       * @return the decoded message or <code>null</code> if nothing was decoded
    53       */
    54      OUTPUT decode(INPUT input, DECODING_STATE context);
    55
    56      /**
    57       * Finish decoding, for example if the decoder accumulated some unused input, it should discard it, or throw an
    58       * Exception
    59       */
    60      void finishDecode(DECODING_STATE context);
    61  }